#ifndef _MINIMAPMODEL_H_
#define _MINIMAPMODEL_H_

#include "Model.h"
#include "Camera.h"

#include <list>

using std::list;

class CameraViewModel : public Model
{
public:
	bool Initialize(CameraClass* renderingCamera, float viewWidth, float viewHeight, float posX, float posY);
	void Frame();
	void Render();

	CameraClass* GetCamera();
	GLuint GetDrawBuffer();

	inline bool GetWireFrame()
	{
		return m_Wireframe;
	}

	inline void ToggleWireFrame()
	{
		m_Wireframe = !m_Wireframe;
	}

	inline float GetViewWidth()
	{
		return m_viewWidth;
	}

	inline float GetViewHeight()
	{
		return m_viewHeight;
	}

private:
	bool InitializeModel();
	bool InitializeRenderBuffer();

private:
	CameraClass* m_Camera;
	GLuint m_drawBufferName;
	GLuint m_drawDepthBuffer;
	GLenum m_drawBuffers[1];
	bool m_Wireframe;
	float m_viewWidth;
	float m_viewHeight;

};
#endif