#include "Font.h"

bool Font::Initialize(char* textureFilename, char* dataFilename)
{
	bool result;
	
	LoadTexture(textureFilename);

	result = LoadFontData(dataFilename);
	if (!result)
	{
		return false;
	}

}

bool Font::LoadFontData(char* dataFilename)
{
	ifstream fin;
	char temp;

	m_Font = new FontType[95];
	if (!m_Font)
	{
		return false;
	}

	fin.open(dataFilename);
	if (fin.fail())
	{
		return false;
	}

	for (int i = 0; i < 95; i++)
	{
		fin.get(temp);
		while (temp != ' ')
		{
			fin.get(temp);
		}
		fin.get(temp);
		while (temp != ' ')
		{
			fin.get(temp);
		}

		fin >> m_Font[i].left;
		fin >> m_Font[i].right;
		fin >> m_Font[i].size;
	}

	fin.close();

	return true;
}

bool Font::GetCharCoordinates(char character, float& left, float& right, float& size)
{
	int letter;

	letter = ((int)character) - 32;
	if (letter > 95)
		return false;

	left = m_Font[letter].left;
	right = m_Font[letter].right;
	size = m_Font[letter].size;

	return true;
}


void Font::LoadTexture(char* textureFilename)
{
	m_Texture = SOIL_load_OGL_texture(textureFilename, SOIL_LOAD_AUTO, SOIL_CREATE_NEW_ID, SOIL_FLAG_MIPMAPS | SOIL_FLAG_NTSC_SAFE_RGB | SOIL_FLAG_COMPRESS_TO_DXT);
}

GLuint Font::GetFontTexture()
{
	return m_Texture;
}
