#ifndef _MODELOBJECT_H_
#define _MODELOBJECT_H_

#define _USE_MATH_DEFINES

#include <math.h>

#include "TerrainModel.h"

class ModelObject
{
protected:
	struct Vector3
	{
		float x, y, z;
	};

public:
	ModelObject();
	ModelObject(const ModelObject&);
	~ModelObject();

	virtual bool Initialize(char*);
	virtual void Frame(float);
	virtual void Shutdown();

	Model* GetModel();

	float GetTransformMatrixValue(int, int);

	void GetTranslation(float&, float&, float&);
	void GetRotation(float&, float&, float&);
	void GetScaling(float&, float&, float&);

	void SetTranslation(float, float, float);
	void SetRotation(float, float, float);
	void SetScaling(float, float, float);


protected:
	void CalculateTransformMatrix();
	void MatrixMultiply(float[4][4], float[4][4], float[4][4]);

protected:
	Model* m_Model;
	float TransformationMatrix[4][4];
	Vector3 m_translate;
	Vector3 m_rotate;
	Vector3 m_scale;
	float total_dt;
};
#endif