#ifndef _OBJMODEL_H_
#define _OBJMODEL_H_

#include <vector>

#include "Model.h"
#include "Material.h"

class ObjModel : public Model
{
private:
	struct Mesh
	{
		VertexType* m_vertexList;
		Material* m_material;
		int m_vertexCount;
	};

	struct LoadMesh
	{
		LoadFace* m_faces;
		int numFaces;
	};

public:
	bool Initialize(char* filename);
	void Render();

private:
	bool ReadFileCount(char* modelFilename, int& vertexCount, int& textureCount, int& normalCount, int& faceCount);
	bool LoadDataStructures(char* modelFilename, int vertexCount, int textureCount, int normalCount, int faceCount);

private:
	int m_meshCount;
	Mesh* m_meshes;
	vector<int> facesPerMesh;
	float *vertex_array, *tex_array, *normal_array;

};


#endif