#ifndef _PRIMITIVEMODELS_H_
#define _PRIMITIVEMODELS_H_

#include "Model.h"
#include "utility_math.h"

class Plane : public Model
{
public:
	bool Initialize(int quadsPerFace, int textureRepeats);
	bool InitializeIndexed(int quadsPerFace, int textureRepeats);
private:
	void AssignVertex(int& vertex_count, int& index_count, int subdivisions, int textureRepeats, float tx, float tz, float x, float y, float z);
};

class Disc : public Model
{
public:
	bool Initialize(int numSegs);
};

class Cube : public Model
{
public:
	bool Initialize(int quadsPerFace, int textureRepeat);
};

class Sphere : public Model
{

};

class CubeSphere : public Model
{
public:
	bool Initialize(int quadsPerFace, int textureRepeat);
	void LerpCubeSphere(float dt);

private:
	bool InitCube(int quadsPerFace, int textureRepeat);

private:
	float lerpS;
	bool rising;
};

class GeodesicSphere : public Model
{
public:
	bool Initialize(int resolution);
	void GeodesicSphereNoise(float dt);
	void Render();

private:
	int GeodesicVertexCount(int subdivisions);
	void subdivide_and_index(float v1[3], float v2[3], float v3[3], long depth);

private:
	int current_index_count;
	int current_vertex_count;
};

#endif