#ifndef _SKYPLANEMODEL_H_
#define _SKYPLANEMODEL_H_

#include "Model.h"
#include "TextureCombiner.h"

class SkyPlaneModel : public Model
{
public:

	bool Initialize(char* cloud_textureA, char* cloud_textureB, char* perturbTexture);
	void Render();
	void Frame(float dt);
	void Shutdown();

private:
	bool InitializeSkyPlane(int skyPlaneResolution, float skyPlaneWidth, float skyPlaneTop, float skyPlaneBottom, int textureRepeat);
	bool LoadTextures(const char* cloud_textureA, const char* cloud_textureB, char* perturbTexture);

private:
	GLuint m_cloudTextureA;
	GLuint m_cloudTextureB;
	BumpMap* m_perturbTexture;
	float m_brightness;
	float m_perturbScale[4];
	double m_perturbTranslation[4];

};


#endif