#include "SpaceObject.h"

SpaceObject::SpaceObject()
{
	orbitTarget = nullptr;
	orbitDistance = 0;
	orbitDistance = 0;
	localTranslate.x = 0;
	localTranslate.y = 0;
	localTranslate.z = 0;
	localRotate.x = 0;
	localRotate.y = 0;
	localRotate.z = 0;
	localScale.x = 0;
	localScale.y = 0;
	localScale.z = 0;

	m_Model = nullptr;
	m_translate.x = 0;
	m_translate.y = 0;
	m_translate.z = 0;
	m_rotate.x = 0;
	m_rotate.y = 0;
	m_rotate.z = 0;
	m_scale.x = 1;
	m_scale.y = 1;
	m_scale.z = 1;
}

SpaceObject::~SpaceObject()
{
}

bool SpaceObject::Initialize(char* modelFilename)
{
	bool result;

	m_Model = new Model;
	if (!m_Model)
	{
		return false;
	}

	//m_Model->Initialize(modelFilename);

	orbitalTicker = 0;

	return true;
}

void SpaceObject::Frame(float dt)
{	
	float dt_ms = (dt * 1000);

	if (orbitTarget)
	{
		orbitalTicker = fmod((orbitalTicker + ((dt_ms) *orbitSpeed)), 360);
	//	orbitalTicker = ((int)(orbitalTicker + orbitSpeed) % 360);

		localTranslate.x = (orbitDistance*sin(orbitalTicker) * 0.05);
		localTranslate.z = (orbitDistance*cos(orbitalTicker) * 0.05);

		Vector3 targetTranslation;
		orbitTarget->GetTranslation(targetTranslation.x, targetTranslation.y, targetTranslation.z);

		m_translate.x = targetTranslation.x + localTranslate.x;
		m_translate.y = targetTranslation.y + localTranslate.y;
		m_translate.z = targetTranslation.z + localTranslate.z;
	}

	m_rotate.y += (0.1f *dt_ms);

	CalculateTransformMatrix();
}

void SpaceObject::Shutdown()
{
	if (m_Model)
	{
		m_Model->Shutdown();
		delete m_Model;
		m_Model = nullptr;
	}

	orbitTarget = nullptr;
}

void SpaceObject::SetOrbitDistance(float distance)
{
	orbitDistance = distance;
}

void SpaceObject::SetOrbitSpeed(float speed)
{
	orbitSpeed = speed;
}

void SpaceObject::SetOrbitTarget(SpaceObject* target)
{
	orbitTarget = target;
}
