#include "TextModel.h"

void TextModel::Initialize(char* filename)
{
	LoadModel(filename);
}

bool TextModel::LoadModel(char* filename)
{
	ifstream fin;
	char input;
	char* error;
	int i;

	//Open the model file
	fin.open(filename);

	//If it could not open the file then exit
	if (fin.fail())
	{
		return false;
	}

	//Read up to the value of the vertex count
	fin.get(input);
	while (input != ':')
	{
		fin.get(input);
	}

	//Read in the vertex count
	fin >> m_vertexCount;

	//Create the model using the vertex count that was read in
	m_vertices = new VertexType[m_vertexCount];
	if (!m_vertices)
	{
		return false;
	}

	//Read up to the beginning of the data
	fin.get(input);
	while (input != ':')
	{
		fin.get(input);
	}
	fin.get(input);
	fin.get(input);

	//Read in the vertex data
	for (i = 0; i < m_vertexCount; i++)
	{
		fin >> m_vertices[i].x >> m_vertices[i].y >> m_vertices[i].z;
		fin >> m_vertices[i].tu >> m_vertices[i].tv;
		fin >> m_vertices[i].nx >> m_vertices[i].ny >> m_vertices[i].nz;
	}

	//Close the model file
	fin.close();

	return true;
}